#!/bin/sh
erased=0;

try_umount_data_partition()
{	
    mount | grep '/data'
    if [ $? -eq 0 ];    then  
       if [ -x /etc/init.d/60data ]; then
          echo "mv data"
          mv   /etc/init.d/60data  /etc/init.d/kk60data
       fi
       cd /
       umount  /data
       if [ $? -ne 0 ];    then  
          echo "umt dt err!"	
       fi  
    fi
}

mount_data_partition()
{	
    if [ ! -d /data ]; then
       mkdir -p /data
    	 if [ $? -ne 0 ]; then
    	    echo  "ERROR:\nCannot not create mountpoint /data\n";
    			exit 15;
    	 fi
       chmod 777 /data
    fi
    
    mount  /dev/mtdblock6  /data
    
    return $?;
}

erase_data_partition()
{	
   if [ $erased -eq 0 ];    then  
   	   sleepTime=$1;
   	   erased=1;
   	  
   	   modprobe chipreg
   	   modprobe mtdcore
       modprobe mtdchar
       modprobe mtdpart
       modprobe mtdblock
       modprobe cmdlinepart mtdparts="aumb3000-nand:1024k(mboot1),3072k(kernel1),3072k(kernel2),7168k(initrd1),7168k(initrd2),98304k(rootfs),-(data)"
       modprobe nand
       modprobe aumb3000_nand
       usleep   ${sleepTime};	
       flash_eraseall /dev/mtd6
   fi
}

#read from $1,then add 1,then write back
I2crw_read_and_writeback()
{	
	 addr_reg=$1;
   /ezdvr/usrbin/Ezi2crw 0xA1 ${addr_reg} 0
   tmp1=$?
   tmp2=`expr $tmp1 + 1` 
   /ezdvr/usrbin/Ezi2crw 0xA0 ${addr_reg} ${tmp2}
}

try_umount_data_partition ;

#read data partition mount wrongly times;
/ezdvr/usrbin/Ezi2crw 0xA1 0x1 0x00 v
mountErr=$?
if [ ${mountErr} -gt 255 ]; then
   mountErr=0
fi
#read app run wrongly times;
/ezdvr/usrbin/Ezi2crw 0xA1 0x2 0x00 v
appErr=$?
if [ ${appErr} -gt 255 ]; then
   appErr=0
fi
if [ ${mountErr} -gt 6 -o ${appErr} -gt 6 ];    then
	 I2crw_read_and_writeback 0x3;
	 erase_data_partition 30000;
fi

I2crw_read_and_writeback 0x1;
mount_data_partition ;
if [ $? -eq 0 ];    then
   /ezdvr/usrbin/Ezi2crw 0xA0 0x1 0x0  
   chmod 777 /data
   #if [ ! -x /data/ezdvr/ezdvr ]; then
   file1opt=` ls -l /ezdvr/ezdvr | awk '{printf $5 $6 $7}' `
   file2opt=` ls -l /data/ezdvr/ezdvr | awk '{printf $5 $6 $7}' `
   if [ "X${file1opt}" != "X${file2opt}" ]; then
      if [ $erased -eq 0 ];    then  
      	 try_umount_data_partition ;
   	     erase_data_partition 1000000;
   	     mount_data_partition ;
   	     if [ $? -eq 0 ];    then
   	     		echo "cp"
            cp -rfp  /ezdvr  /data
   	     fi
   	  else
   	     echo "cp"
         cp -rfp  /ezdvr  /data
   	  fi
   fi
else
   echo "mt dt err!"
fi

echo  "done"